void initESC()
{
  motor.writeMicroseconds(1500);
  delay(1000);
  motor.writeMicroseconds(1980);
  delay(2000);
  motor.writeMicroseconds(1500);
  delay(2000);
  motor.writeMicroseconds(1020);
  delay(2000);
  motor.writeMicroseconds(1500);
}

void drive()
{
  //logic goes here
  throttle(fwdSpeed);
  while (ping() > 15){
    foo(); //check for a new command
    if (lastState != 1)  //check if a stop command has been received
    {
      throttle(fullStop);  //do I need this?
      return;  //exit the loop and return to the main loop
    }
  } //herp
  throttle(fullStop);
  for ( int i = 0; i < 3; i++) {
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(500);
  }
  reverse();
  turnRight();
  delay(5000);
  center();
  throttle(1500);
  //derp
  foo();
  if (lastState == 1){
      drive();
    }  
  
}

void reverse()
{
  throttle(revSpeed);
  if (digitalRead(irPin) == LOW){
    throttle(1500);
  }
}

void turnLeft()
{
  Serial.println("Turning Left");
  steering.writeMicroseconds(2000);
  rear.writeMicroseconds(1500);
}

void turnRight()
{
  Serial.println("Turning Right");
  steering.writeMicroseconds(1000);
  rear.writeMicroseconds(1500);
}

void center()
{
  Serial.println("Centering steering");
  steering.writeMicroseconds(1500);
  rear.writeMicroseconds(1500);
}

void throttle( int mspeed )
{
  //Serial.println("Throttle set to " + mspeed);
  motor.writeMicroseconds(mspeed);
}

void foo()
{
//manual controls
  clearToRun = Serial.read();
  switch (clearToRun) {
  case 'w':  //drive
    Serial.println("Entering Running State");
    lastState = 1;
    drive();
    break;
  case 'q':
    Serial.println("Stopping");
    lastState = 0;
    throttle(fullStop);
    break;
  case 'a':
    turnLeft();
    break;
  case 'd':
    turnRight();
    break;
  case 'c':
    //Calibrate the ESC on powerup
    Serial.println("Calibrating ESC");
    initESC();
    break;
  case 'e':
    //Center steering servo
    center();
    break;
  case 's': //reverse
    reverse();
    break;
  case '1': //low speed
    fwdSpeed = 1650;
    break;
  case '2': //medium speed
    fwdSpeed = 1700;
    break;
  case '3': //full speed
    fwdSpeed = 1980;
    break;
  case '4': //slow reverse
    revSpeed = 1400;
    Serial.println("Slow reverse speed");
    break;
  case '5': //full reverse
    revSpeed = 1200;
    Serial.println("Full reverse speed");
    break;
  case -1: //when no command is transmitted, this is what's received, dead air
    
    break; 
  default:
    break; //same here
  }
}
